(******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***   Assa's EventMonTray                                                  ***
 ***   Version [1.00]                               {Last mod 2003-07-08}   ***
 ***                                                                        ***
 ******************************************************************************
 ******************************************************************************

                                 _\\|//_
                                (` * * ')
 ______________________________ooO_(_)_Ooo_____________________________________
 ******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***                Copyright (c) 1995 - 2003 by -=Assarbad=-               ***
 ***                                                                        ***
 ***   CONTACT TO THE AUTHOR(S):                                            ***
 ***    ____________________________________                                ***
 ***   |                                    |                               ***
 ***   | -=Assarbad=- aka Oliver            |                               ***
 ***   |____________________________________|                               ***
 ***   |                                    |                               ***
 ***   | Assarbad@gmx.info|.net|.com|.de    |                               ***
 ***   | ICQ: 281645                        |                               ***
 ***   | AIM: nixlosheute                   |                               ***
 ***   |      nixahnungnicht                |                               ***
 ***   | MSN: Assarbad@ePost.de             |                               ***
 ***   | YIM: sherlock_holmes_and_dr_watson |                               ***
 ***   |____________________________________|                               ***
 ***             ___                                                        ***
 ***            /   |                     ||              ||                ***
 ***           / _  |   ________ ___  ____||__    ___   __||                ***
 ***          / /_\ |  / __/ __//   |/  _/|   \  /   | /   |                ***
 ***         / ___  |__\\__\\  / /\ || |  | /\ \/ /\ |/ /\ | DOT NET        ***
 ***        /_/   \_/___/___/ /_____\|_|  |____/_____\\__/\|                ***
 ***       ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~        ***
 ***              [http://assarbad.net | http://assarbad.org]               ***
 ***                                                                        ***
 ***   Notes:                                                               ***
 ***   - my first name is Oliver, you may well use this in your e-mails     ***
 ***   - for questions and/or proposals drop me a mail or instant message   ***
 ***                                                                        ***
 ***~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~***
 ***              May the source be with you, stranger ... ;)               ***
 ***    Snizhok, eto ne tolko fruktovij kefir, snizhok, eto stil zhizn.     ***
 ***                     Vsem Privet iz Germanij                            ***
 ***                                                                        ***
 *** Greets from -=Assarbad=- fly to YOU =)                                 ***
 *** Special greets fly 2 Nico, Casper, SA, Pizza, Navarion, Eugen, Zhenja, ***
 *** Xandros, Melkij, Strelok etc pp.                                       ***
 ***                                                                        ***
 *** Thanks to:                                                             ***
 *** W.A. Mozart, Vivaldi, Beethoven, Poeta Magica, Kurtzweyl, Manowar,     ***
 *** Blind Guardian, Weltenbrand, In Extremo, Wolfsheim, Carl Orff, Zemfira ***
 *** ... most of my work was done with their music in the background ;)     ***
 ***                                                                        ***
 ******************************************************************************
 ******************************************************************************

 LEGAL STUFF:
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

 Copyright (c) 1995-2003, -=Assarbad=- ["copyright holder(s)"]
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
 3. The name(s) of the copyright holder(s) may not be used to endorse or
    promote products derived from this software without specific prior written
    permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                             .oooO     Oooo.
 ____________________________(   )_____(   )___________________________________
                              \ (       ) /
                               \_)     (_/

 ******************************************************************************)

program eventnote;
uses
  Windows,
  Messages,
  ShellApi;

(*
  Almost no error checking. No overflow checking ... quick'n'dirty ... ;)

  BUT there's a big big advantage over "Mobius EventMonTray" ... this one can
  virtually handle up to 256 eventlogs!

  Note, that a W2K Pro has 3 eventlogs, but e.g. W2K Srv may have 6, or 5 or 7 ...
*)


{$R main.res}
{$INCLUDE .\Include\FormatString.pas}
{$APPTYPE GUI}

const
  Classname = 'AssasEventMonWndFakeClass';
  note_hint = 'EventMonTray';
  IDI_ICON1 = 104;
  IDR_MENU1 = 105;
  IDI_ICON2 = 106;
  IDI_ICON3 = 107;
  ID_CLOSE = 40001;
  ID_OPENEVENTLOGVIEWER = 40003;
  ID_ABOUTEVENTMONTRAY = 40004;
  ID_RESETCOUNTER = 40005;
  WM_SHELLNOTIFY = WM_USER + 666;
  SC_TRAY = WM_USER + 666 - 1;
  servicekey = 'SYSTEM\CurrentControlSet\Services\Eventlog';
  EventPrefix = 'AssaEventMonTray_%s';
  maxlogs = $FF; // Maximum number of logs is $FF+1

var
  ThreadID: DWORD;
  MsgTaskbarcreated: DWORD = 0;
  note: TNotifyIconData = (
    cbSize: SizeOf(TNotifyIconData);
    uID: SC_TRAY;
    uFlags: NIF_ICON or NIF_MESSAGE or NIF_TIP;
    uCallbackMessage: WM_SHELLNOTIFY;
    szTip: note_hint;
    );
  eventIcon,
    noeventIcon,
    appIcon: HICON;
  hPopMenu: THandle = 0;
  wc: TWndClassEx = (
    cbSize: SizeOf(TWndClassEx);
    style: CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS;
    cbClsExtra: 0;
    cbWndExtra: 0;
    lpszMenuName: nil;
    lpszClassName: ClassName;
    hIconSm: 0; );
  msg: TMsg;
  idx: Integer;
  Blink: Boolean = False;
  events: array[0..maxlogs] of THandle; // notification event handles
  logs: array[0..maxlogs] of THandle; // event log handles
  lognames: array[0..maxlogs] of string; // event log names
  numevents: array[0..maxlogs] of DWORD; // number of events per eventlog upon last counter reset
  totnumevents: array[0..maxlogs] of DWORD; // total number of events per eventlog

procedure CreateTrayIcon(hwnd: HWND);
begin
  note.cbSize := SizeOf(TNotifyIconData);
  note.wnd := hwnd;
  note.uID := SC_TRAY;
  note.uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
  note.uCallbackMessage := WM_SHELLNOTIFY;
  note.hIcon := appIcon;
  lstrcpyn(@note.szTip[0], @note_hint[1], sizeof(note.szTip));
  ShowWindow(hWnd, SW_HIDE);
  Shell_NotifyIcon(NIM_ADD, @note);
end;

procedure DestroyTrayIcon;
begin
  Shell_NotifyIcon(NIM_DELETE, @note);
end;

procedure ModifyTrayIconText;
var
  i: DWORD;
  s: string;
begin
  s := '';
  for i := 0 to idx - 1 do
    if GetNumberOfEventLogRecords(logs[i], totnumevents[i]) then
      s := s + Format(Copy(lognames[i], 1, 2) + '[%d/%d]', [totnumevents[i], totnumevents[i] - numevents[i]]);
  lstrcpyn(@note.szTip[0], @s[1], sizeof(note.szTip));
  Shell_NotifyIcon(NIM_MODIFY, @note);
end;

procedure ResetCounter;
var
  i: DWORD;
begin
  Blink := False;
  ZeroMemory(@numevents, sizeof(numevents));
  for i := 0 to idx - 1 do
    GetNumberOfEventLogRecords(logs[i], numevents[i]);
  ModifyTrayIconText;
end;

function MonitorThread(lParam: PNotifyIconData): DWORD; stdcall;
var
  i: Integer;
  ret: DWORD;
begin
  ResetCounter;
  for i := 0 to idx - 1 do
    NotifyChangeEventLog(logs[i], events[i]);
  while True do
  begin
    ret := WaitForMultipleObjects(idx, @events, False, 1000);
    if ret <> WAIT_TIMEOUT then
    begin
      Blink := True;
      ModifyTrayIconText;
    end;
  end;
  result := 0;
end;

procedure BlinkTrayIcon;
begin
  if not Blink then
    exit;
  if note.hIcon = eventIcon then
    note.hIcon := noeventIcon
  else
    note.hIcon := eventIcon;
  ModifyTrayIconText;
end;

procedure TimerFunc(hwnd: HWND; uMsg: UINT; idEvent: UINT; dwTime: DWORD); stdcall;
begin
  BlinkTrayIcon;
end;

function WndProc(hWnd, uMsg: Cardinal; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
var
  hReg: HKEY;
  bufsize, err: DWORD;
  ft: FILETIME;
  namebuf: array[0..MAX_PATH] of char;
  i: LongInt;
begin
  result := 0;
  case uMsg of
    WM_CREATE:
      begin
        err := RegOpenKey(HKEY_LOCAL_MACHINE, servicekey, hReg);
        if err = ERROR_SUCCESS then
        try
          bufsize := sizeof(namebuf);
          ZeroMemory(@namebuf, bufsize);
          idx := 0;
          while RegEnumKeyEx(hReg, idx, @namebuf, bufsize, nil, nil, nil, @ft) = ERROR_SUCCESS do
          begin
            events[idx] := CreateEvent(nil, True, False, @Format(EventPrefix, [@namebuf])[1]);
            logs[idx] := OpenEventLog(nil, @namebuf);
            SetString(lognames[idx], PChar(@namebuf), lstrlen(@namebuf));
            bufsize := sizeof(namebuf);
            ZeroMemory(@namebuf, bufsize);
            inc(idx);
            if idx > maxlogs then
              Break;
          end;
        finally
          RegCloseKey(hReg);
        end;
        CreateTrayIcon(hwnd);
        SetTimer(hwnd, SC_TRAY, 500, @TimerFunc);
        CreateThread(nil, 0, @MonitorThread, @note, 0, ThreadID);
        MsgTaskbarcreated := RegisterWindowMessage('TaskbarCreated');
      end;
    WM_CLOSE:
      begin
        DestroyTrayIcon;
        for i := 0 to idx - 1 do
          CloseEventLog(logs[i]);
        Result := DefWindowProc(hWnd, uMsg, wParam, lParam);
      end;
    WM_DESTROY:
      PostQuitMessage(0);
    WM_TIMER: ;
    WM_SHELLNOTIFY:
      case wParam of
        SC_TRAY:
          case lParam of
            WM_LBUTTONDBLCLK:
              begin
                ResetCounter;
                ShellExecute(hwnd, 'open', 'eventvwr.exe', nil, nil, SW_SHOW);
              end;
            WM_RBUTTONDOWN:
              Sendmessage(hwnd, WM_CLOSE, 0, 0);
          end;
      end;
  else
    if ((MsgTaskbarcreated <> 0) and (uMsg = MsgTaskbarcreated)) then
    begin
      DestroyTrayIcon;
      CreateTrayIcon(hwnd);
    end
    else
      Result := DefWindowProc(hWnd, uMsg, wParam, lParam);
  end;
end;

begin
  appIcon := LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1));
  eventIcon := LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON2));
  noeventIcon := LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON3));
  hPopmenu := LoadMenu(hInstance, MAKEINTRESOURCE(IDR_MENU1));
  wc.hinstance := hinstance;
  wc.lpfnWndProc := @WndProc;
  RegisterClassEx(wc);
  CreateWindowEx(0, wc.lpszClassName, nil, 0, 0, 0, 0, 0, 0, 0, hinstance, nil);
  while GetMessage(msg, 0, 0, 0) do
  begin
    TranslateMessage(msg);
    DispatchMessage(msg);
  end;
end.

